Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.crypto
Class CipherSpi

    java.lang.Object
      |
      +--javax.crypto.CipherSpi

public abstract class CipherSpi
extends Object

This class defines the Service Provider Interface (SPI) for the Cipher class. All the abstract methods in this class must be implemented by each cryptographic service provider who wishes to supply the implementation of a particular cipher algorithm.

In order to create an instance of Cipher, which encapsulates an instance of this CipherSpi class, an application calls the getInstance method of Cipher and specifies the requested transformation. Optionally, the application may also specify the name of a provider.

A transformation is a string that describes the operation (or set of operations) to be performed on the given input, to produce some output. A transformation always includes the name of a cryptographic algorithm (e.g., DES), and may be followed by a feedback mode and padding scheme. A transformation is of the form: algorithm or algorithm/mode/padding (in the former case, defaults are used for mode and padding). For example, DES/CBC/PKCS5Padding represents a valid transformation.

A provider may supply a separate class for each combination of algorithm/mode/padding, or may decide to provide more generic classes representing sub-transformations corresponding to algorithm or algorithm/mode, whose mode and/or padding schemes can be set using engineSetMode and engineSetPadding, respectively.

For example, a provider may supply a subclass of CipherSpi that implements DES/ECB/PKCS5Padding, one that implements DES/CBC/PKCS5Padding, one that implements DES/CFB/PKCS5Padding, and yet another one that implements DES/OFB/PKCS5Padding.

A different provider may implement a class for each of the above modes (i.e., one class for ECB, one for CBC, one for CFB, and one for OFB), one class for PKCS5Padding, and a generic DES class that subclasses from CipherSpi.

The algorithm for instantiating a Cipher object (using one of the getInstance methods) when a transformation of the form algorithm is given is as follows:

- Check if the provider has registered a subclass of Cipher for the specified algorithm. If the answer is YES, instantiate this class, for whose mode and padding scheme default values (as supplied by the provider) are used. If the answer is NO, throw a NoSuchAlgorithmException exception.

The algorithm for instantiating a CipherSpi object when a transformation of the form algorithm/mode/padding is given is as follows:

- Check if the provider has registered a subclass of CipherSpi for the specified algorithm/mode/padding transformation. If the answer is YES, instantiate this class and return it to the user. If the answer is NO, go to the next step.
- Check if the provider has registered a subclass of CipherSpi for the sub-transformation algorithm/mode. If the answer is YES, instantiate this class, and call engineSetPadding(padding) on the new instance, before returning it to the user. If the answer is NO, go to the next step.
- Check if the provider has registered a subclass of CipherSpi for the sub-transformation algorithm. If the answer is YES, instantiate this class, and call engineSetMode(mode) and engineSetPadding(padding) on the new instance, before returning it to the user. If the answer is NO, throw a NoSuchAlgorithmException exception.

See Also:
  `KeyGenerator`, `SecretKey`, `java.security.KeyPairGenerator`, `PublicKey`, `PrivateKey`, `AlgorithmParameters`, `AlgorithmParameterSpec`

Field Summary
`protected int` | `state`

Constructor Summary
`CipherSpi()`

Method Summary
`protected abstract byte[]` | `engineDoFinal(byte[] input, int inputOffset, int inputLen)` Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation.
`protected abstract int` | `engineDoFinal(byte[] input, int inputOffset, int inputLen, byte[] output, int outputOffset)` Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation.
`protected abstract int` | `engineGetBlockSize()` Returns the block size (in bytes).
`protected abstract byte[]` | `engineGetIV()` Returns the initialization vector (IV) in a new buffer.
`protected abstract int` | `engineGetOutputSize(int inputLen)` Returns the length in bytes that an output buffer would need to be in order to hold the result of the next update or doFinal operation, given the input length inputLen (in bytes).
`protected abstract AlgorithmParameters` | `engineGetParameters()` Returns the parameters used with this cipher.
`protected abstract void` | `engineInit(int opmode, Key key, AlgorithmParameterSpec params, SecureRandom random)` Initializes this cipher with a key, a set of algorithm parameters and a source of randomness.
`protected abstract void` | `engineInit(int opmode, Key key, AlgorithmParameters params, SecureRandom random)` Initializes this cipher with a key, a set of algorithm parameters and a source of randomness.
`protected abstract void` | `engineInit(int opmode, Key key, SecureRandom random)` Initializes this cipher with a key and a source of randomness.
`protected abstract void` | `engineSetMode(String mode)` Sets the mode of this cipher.
`protected abstract void` | `engineSetPadding(String padding)` Sets the padding mechanism of this cipher.
`protected abstract byte[]` | `engineUpdate(byte[] input, int inputOffset, int inputLen)` Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.
`protected abstract int` | `engineUpdate(byte[] input, int inputOffset, int inputLen, byte[] output, int outputOffset)` Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### state

    protected int state

Constructor Detail

### CipherSpi

    public CipherSpi()

Method Detail

### engineSetMode

    protected abstract void engineSetMode(String mode)
                                   throws NoSuchAlgorithmException

  Sets the mode of this cipher.
  Parameters:
    `mode` - the cipher mode
  Throws:
    NoSuchAlgorithmException - if the requested cipher mode does not exist

### engineSetPadding

    protected abstract void engineSetPadding(String padding)
                                      throws NoSuchPaddingException

  Sets the padding mechanism of this cipher.
  Parameters:
    `padding` - the padding mechanism
  Throws:
    NoSuchPaddingException - if the requested padding mechanism does not exist

### engineGetBlockSize

    protected abstract int engineGetBlockSize()

  Returns the block size (in bytes).

  Returns:
    the block size (in bytes), or 0 if the underlying algorithm is not a block cipher

### engineGetOutputSize

    protected abstract int engineGetOutputSize(int inputLen)

  Returns the length in bytes that an output buffer would need to be in order to hold the result of the next update or doFinal operation, given the input length inputLen (in bytes).

  This call takes into account any unprocessed (buffered) data from a previous update call, and padding.

  The actual output length of the next update or doFinal call may be smaller than the length returned by this method.

  Parameters:
    `inputLen` - - the input length (in bytes)
  Returns:
    the required output buffer size (in bytes)

### engineGetIV

    protected abstract byte[] engineGetIV()

  Returns the initialization vector (IV) in a new buffer.

  This is useful in the context of password-based encryption or decryption, where the IV is derived from a user-provided passphrase.

  Returns:
    the initialization vector in a new buffer, or null if the underlying algorithm does not use an IV, or if the IV has not yet been set.

### engineInit

    protected abstract void engineInit(int opmode,
                                       Key key,
                                       SecureRandom random)
                                throws InvalidKeyException

  Initializes this cipher with a key and a source of randomness.

  The cipher is initialized for encryption or decryption, depending on the value of opmode.

  If this cipher requires an initialization vector (IV), it will get it from random. The random IV can be retrieved using getIV. This behaviour should only be used in encryption mode, however. When initializing a cipher that requires an IV for decryption, the IV (same IV that was used for encryption) must be provided explicitly as a parameter, in order to get the correct result. Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher, and initializing it.

  Parameters:
    `opmode` - the operation mode of this cipher (this is either ENCRYPT_MODE or DECRYPT_MODE)
    `key` - the encryption key
    `random` - the source of randomness
  Throws:
    InvalidKeyException - if the given key is inappropriate for initializing this cipher

### engineInit

    protected abstract void engineInit(int opmode,
                                       Key key,
                                       AlgorithmParameterSpec params,
                                       SecureRandom random)
                                throws InvalidKeyException,
                                       InvalidAlgorithmParameterException

  Initializes this cipher with a key, a set of algorithm parameters and a source of randomness.

  The cipher is initialized for encryption or decryption, depending on the value of opmode. If this cipher (including its underlying feedback or padding scheme) requires any random bytes, it will get them from random. Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher, and initializing it.

  Parameters:
    `opmode` - the operation mode of this cipher (this is either ENCRYPT_MODE or DECRYPT_MODE)
    `key` - the encryption key
    `params` - the algorithm parameters
    `random` - the source of randomness
  Throws:
    InvalidKeyException - if the given key is inappropriate for initializing this cipher
    InvalidAlgorithmParameterException - if the given algorithm parameters are inappropriate for this cipher

### engineInit

    protected abstract void engineInit(int opmode,
                                       Key key,
                                       AlgorithmParameters params,
                                       SecureRandom random)
                                throws InvalidKeyException,
                                       InvalidAlgorithmParameterException

  Initializes this cipher with a key, a set of algorithm parameters and a source of randomness.

  The cipher is initialized for encryption or decryption, depending on the value of opmode.

  f this cipher requires any algorithm parameters and params is null, the underlying cipher implementation is supposed to generate the required parameters itself (using provider-specific default or random values) if it is being initialized for encryption, and raise an InvalidAlgorithmParameterException if it is being initialized for decryption. The generated parameters can be retrieved using engineGetParameters or engineGetIV (if the parameter is an IV).

  Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher, and initializing it.

  Parameters:
    `opmode` - the operation mode of this cipher (this is either ENCRYPT_MODE or DECRYPT_MODE)
    `key` - the encryption key
    `params` - the algorithm parameters
    `random` - the source of randomness
  Throws:
    InvalidKeyException - if the given key is inappropriate for initializing this cipher
    InvalidAlgorithmParameterException - if the given algorithm parameters are inappropriate for this cipher, or if this cipher is being initialized for decryption and requires algorithm parameters and params is null

### engineUpdate

    protected abstract byte[] engineUpdate(byte[] input,
                                           int inputOffset,
                                           int inputLen)

  Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

  The first inputLen bytes in the input buffer, starting at inputOffset, are processed, and the result is stored in a new buffer.

  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in input where the input starts
    `inputLen` - the input length
  Returns:
    the new buffer with the result, or null if the underlying cipher is a block cipher and the input data is too short to result in a new block

### engineUpdate

    protected abstract int engineUpdate(byte[] input,
                                        int inputOffset,
                                        int inputLen,
                                        byte[] output,
                                        int outputOffset)
                                 throws ShortBufferException

  Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

  The first inputLen bytes in the input buffer, starting at inputOffset, are processed, and the result is stored in the output buffer, starting at outputOffset.

  If the output buffer is too small to hold the result, a ShortBufferException is thrown. In this case, repeat this call with a larger output buffer. Use getOutputSize to determine how big the output buffer should be.

  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in input where the input starts
    `inputLen` - the input length
    `output` - the buffer for the result
    `outputOffset` - the offset in output where the result is stored
  Returns:
    the number of bytes stored in output
  Throws:
    ShortBufferException - if the given output buffer is too small to hold the result

### engineDoFinal

    protected abstract byte[] engineDoFinal(byte[] input,
                                            int inputOffset,
                                            int inputLen)
                                     throws IllegalBlockSizeException,
                                            BadPaddingException

  Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation. The data is encrypted or decrypted, depending on how this cipher was initialized.

  The first inputLen bytes in the input buffer, starting at inputOffset, and any input bytes that may have been buffered during a previous update operation, are processed, with padding (if requested) being applied. The result is stored in a new buffer.

  A call to this method resets this cipher object to the state it was in when previously initialized via a call to init. That is, the object is reset and available to encrypt or decrypt (depending on the operation mode that was specified in the call to init) more data.

  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in input where the input starts
    `inputLen` - the input length
  Returns:
    the new buffer with the result
  Throws:
    IllegalBlockSizeException - if this cipher is a block cipher, no padding has been requested (only in encryption mode), and the total input length of the data processed by this cipher is not a multiple of block size
    BadPaddingException - if this cipher is in decryption mode, and (un)padding has been requested, but the decrypted data is not bounded by the appropriate padding bytes

### engineDoFinal

    protected abstract int engineDoFinal(byte[] input,
                                         int inputOffset,
                                         int inputLen,
                                         byte[] output,
                                         int outputOffset)
                                  throws ShortBufferException,
                                         IllegalBlockSizeException,
                                         BadPaddingException

  Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation. The data is encrypted or decrypted, depending on how this cipher was initialized.

  The first inputLen bytes in the input buffer, starting at inputOffset, and any input bytes that may have been buffered during a previous update operation, are processed, with padding (if requested) being applied. The result is stored in the output buffer, starting at outputOffset.

  If the output buffer is too small to hold the result, a ShortBufferException is thrown. In this case, repeat this call with a larger output buffer. Use getOutputSize to determine how big the output buffer should be.

  A call to this method resets this cipher object to the state it was in when previously initialized via a call to init. That is, the object is reset and available to encrypt or decrypt (depending on the operation mode that was specified in the call to init) more data.

  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in input where the input starts
    `inputLen` - the input length
    `output` - the buffer for the result
    `outputOffset` - the offset in output where the result is
  Returns:
    the number of bytes stored in output
  Throws:
    IllegalBlockSizeException - if this cipher is a block cipher, no padding has been requested (only in encryption mode), and the total input length of the data processed by this cipher is not a multiple of block size
    ShortBufferException - if the given output buffer is too small to hold the result
    BadPaddingException - if this cipher is in decryption mode, and (un)padding has been requested, but the decrypted data is not bounded by the appropriate padding bytes

### engineGetParameters

    protected abstract AlgorithmParameters engineGetParameters()

  Returns the parameters used with this cipher.

  The returned parameters may be the same that were used to initialize this cipher, or may contain the default set of parameters or a set of randomly generated parameters used by the underlying cipher implementation (provided that the underlying cipher implementation uses a default set of parameters or creates new parameters if it needs parameters but was not initialized with any).

  Returns:
    the parameters used with this cipher, or null if this cipher does not use any parameters.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD